package com.xinelu.manage.mapper.servicewaycontent;

import com.xinelu.manage.domain.servicewaycontent.ServiceWayContent;
import com.xinelu.manage.dto.servicefrequency.ServiceFrequencyDTO;
import com.xinelu.manage.dto.servicewaycontent.ServiceWayContentAddDTO;
import com.xinelu.manage.dto.servicewaycontent.ServiceWayContentDTO;
import com.xinelu.manage.dto.servicewaycontent.ServiceWayContentEditDTO;
import com.xinelu.manage.vo.servicewaycontent.ServiceWayContentAndFrequencyVO;
import com.xinelu.manage.vo.servicewaycontent.ServiceWayContentAndNumVO;
import com.xinelu.manage.vo.servicewaycontent.ServiceWayContentVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 服务方式内容Mapper接口
 *
 * @author xinelu
 * @date 2024-02-29
 */
public interface ServiceWayContentMapper {
    /**
     * 查询服务方式内容
     *
     * @param id 服务方式内容主键
     * @return 服务方式内容
     */
    public ServiceWayContent selectServiceWayContentById(Long id);

    /**
     * 查询服务方式内容列表
     *
     * @param serviceWayContent 服务方式内容
     * @return 服务方式内容集合
     */
    public List<ServiceWayContent> selectServiceWayContentList(ServiceWayContent serviceWayContent);

    /**
     * 新增服务方式内容
     *
     * @param serviceWayContent 服务方式内容
     * @return 结果
     */
    public int insertServiceWayContent(ServiceWayContent serviceWayContent);

    /**
     * 修改服务方式内容
     *
     * @param serviceWayContent 服务方式内容
     * @return 结果
     */
    public int updateServiceWayContent(ServiceWayContent serviceWayContent);

    /**
     * 删除服务方式内容
     *
     * @param id 服务方式内容主键
     * @return 结果
     */
    public int deleteServiceWayContentById(Long id);

    /**
     * 批量删除服务方式内容
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteServiceWayContentByIds(Long[] ids);

    /**
     * 查询服务方式列表
     */
    List<ServiceWayContentAndNumVO> selectListNum(@Param("serviceWayName") String serviceWayName, @Param("id") Long id);

    /**
     * 查询服务方式内容列表
     */
    List<ServiceWayContentVO> selectServiceWayContentListV1(ServiceWayContentDTO serviceWayContentDTO);

    /**
     * 根据服务频次id查询服务内容和服务频次
     */
    ServiceWayContentAndFrequencyVO selectServiceWayContentDetailByFrequencyId(Long id);

    /**
     * 查询服务方式是否存在
     */
    int countByServiceName(String serviceWayName);

    /**
     * 根据id删除服务方式
     */
    int deleteServiceWayById(Long id);

    /**
     * 通过id查询服务方式
     */
    String selectServiceWayById(Long id);


    /**
     * 修改服务方式
     */
    int updateServiceWay(ServiceWayContent serviceWayContent);

    /**
     * 判断同一服务内容下服务频次是否存在
     */
    int countByEditDTO(ServiceWayContentEditDTO serviceWayContentEditDTO);

    /**
     * 根据服务频次id删除服务内容
     */
    int deleteByFrequencyId(Long id);

    /**
     * 判断服务内容在服务内容表中是否存在
     */
    ServiceWayContentVO countByWayIdAndContent(@Param("serviceWayId") Long serviceWayId, @Param("serviceContent") String serviceContent);

    /**
     * 判断服务频次在服务频次表中是否存在
     */
    int countByServiceFrequencyDTO(ServiceFrequencyDTO serviceFrequencyDTO);

    /**
     * 判断当前服务方式下服务内容是否重复
     */
    int selectServiceContentByName(@Param("serviceContent") String serviceContent, @Param("serviceWayId") Long serviceWayId);

    /**
     * 检查TEXT类型的serviceFrequencyText是否重复
     */
    boolean isServiceFrequencyTextDuplicate(@Param("serviceWayContentEditDTO") ServiceWayContentEditDTO serviceWayContentEditDTO);

    /**
     * 检查DIGIT类型的serviceFrequencyStart和serviceFrequencyEnd是否重复
     */
    boolean isServiceFrequencyDigitDuplicate(@Param("serviceWayContentEditDTO") ServiceWayContentEditDTO serviceWayContentEditDTO);

    /**
     * 更新服务频次
     */
    int updateServiceFrequency(ServiceWayContent currentFrequency);
}
